; ***17.11.09*********************************

; Einfach als wdog1.asm in die IDE dazu adden. 

; .include "ez8.inc"
; Hier nur das was ich hier brauche an  SFR Register 

WDTCTL  .equ  %FF0               ; Reset =   %80 Watchdog Timer Control
WDTU    .equ  %FF1               ; Reset =   %FF Watchdog Timer Reload Upper
WDTH    .equ  %FF2               ; Reset =   %FF Watchdog Timer Reload High
WDTL    .equ  %FF3               ; Reset =   %FF Watchdog Timer Reload Low

XSPH    .equ  %FFE               ; Reset =   %XX Stack Pointer High
XSPL    .equ  %FFF               ; Reset =   %XX  Stack Pointer Low 
 

; Subject: 
; **** Z8 Encore! XP F082A *********************************

; A Call param_WDOG_reg see below 
; from high level C Lang.
; will "not" work to parameter the 
; Watchdog-Timer 24 Bit
; You have to wait ap. 24 Minutes. 
; because the countdown starts at 0xFFFFFF

;void param_WDOG_reg (void)
;{
;// unlock 
;asm("LDX %FF0,#%55");// first  Unlock
;asm("LDX %FF0,#%AA");// second Unlock  

; // Coseqently store registers 
;asm("LDX %FF3,#%00");
;asm("LDX %FF2,#%FF");
;asm("LDX %FF1,#%10");
;};


; So I made it in ASM Routine 
; _watch_dog_timer_regs see below.  
; and it works fine. 



; **** Z8 Encore! XP F082A *********************************
; //  0x80 = Bit 5 INTEN Internal Precision Oscillator Enable
; //  0x20 = Bit 7 Watchdog Timer oscillator is enabled

; dont forgett to call Init_Oszi before 

; you later call watch_dog_timer_regs( 0, 0xFF, 0x10 ); 
; because Watchdog Timer oscillator is not enabled
; in OSCCTL Register 




; #define OSC_UNLOCK_SEQ1 0xE7
; #define OSC_UNLOCK_SEQ2 0x18 
;void Init_Oszi (void)
;{
; OSCCTL = OSC_UNLOCK_SEQ1; // Unlock sequence for OSCTL write
; OSCCTL = OSC_UNLOCK_SEQ2; //
;//  0x80 = Bit 5 INTEN Internal Precision Oscillator Enable
;//  0x20 = Bit 7 Watchdog Timer oscillator is enabled

; OSCCTL  = (0x80 | 0x20 );     
; make a short delay ::::: then call 

;  watch_dog_timer_regs( 0, 0xFF, 0x10 ); 

;}

; Now the first Call WDT starts the Watchdog-Timer ... 

;void TrigWatch( void )
;{
;  asm("WDT"); 
; }
; In main you read  RSTSTAT in a variable  
;  bit 0x20 is set, if Wdog causes a Timeout 
; use a variable because the first read  of RSTSTAT 
; clears all the flags.  


.DEF _watch_dog_timer_regs ;  Make  _underscore <prototype>: 
 segment CODE
; *************************

_watch_dog_timer_regs: ; cF1,cF2,cF3 
  ; DI ; No IRQs 
 PUSH R15 ; push save working reg  
 PUSH R14 ; push save working reg  
    LDX  R14,XSPH ; save Stack-PointerH to R14
    LDX  R15,XSPL ; save Stack-PointerL to R15 
    SUBX XSPL,#%03
    SBCX XSPH,#%00
     ; first load all R0,R1,R2 Registers from C-Stack 
     LDX  R0,4(RR14) ; Register Relativ from R14 to R0 Grab F1 passed 8-Bit parameter 
     LDX  R1,5(RR14) ;Grab F2 passed parameter  
     LDX  R2,6(RR14) ;Grab F3 passed parameter 
      ; unlock command 
 	 LDX  WDTCTL, #%55   ; first  Unlock
     LDX  WDTCTL, #%AA   ; second Unlock   
     ; Coseqently store registers 
      LDX WDTU,R0  ; load in WDT-Upper Reg.          
      LDX WDTH,R1  ; load in WDT-Higer Reg.   
      LDX WDTL,R2  ; load in WDT-Lower Reg.      
     ; 
   LDX  XSPL,R15 ; Restore Stack-PointerL from R15 
   LDX  XSPH,R14 ; Restore Stack-PointerH from R14 
 POP  R14
 POP  R15
 ; EI ; enable IRQ-Master
 RET  

; **************************************************
; Hier Funktion im C-Modul anmelden. 
; void watch_dog_timer_regs( char, char, char );

; Beispiel fr die Funktion set_watch_dog_timer_regs

; watch_dog_timer_regs( 0x00, 0x7F, 0xFF );



; Notice the V24 Conection in DBG Port is broken 
; if the WD-Reset was activ. 
; I unplug and plug in my USB-Serial , 
; but after this the conection is ok again. 
; I have no $30 Debugger for USB from ZILOG. 
